export function install(VTU, compatConfig) {
  VTU.config.plugins.VueWrapper.install((wrapper) => {
    const { props } = wrapper;
    return {
      props(prop) {
        const originalProps = props.call(wrapper, prop);
        if (!compatConfig.WRAPPER_UNWRAP_PROPS) {
          return originalProps;
        }

        if (prop === undefined) {
          return new Proxy(originalProps, {
            get(target, key) {
              const value = target[key];
              // eslint-disable-next-line no-underscore-dangle
              return value?.__v_raw ?? value;
            },
          });
        }

        // eslint-disable-next-line no-underscore-dangle
        return originalProps?.__v_raw ?? originalProps;
      },
    };
  });
}
